/**
 * Freqtrade API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 2021.12-dev21
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */

import ApiClient from '../ApiClient';
import StatusMsg from './StatusMsg';
import TradeSchema from './TradeSchema';

/**
 * The ForceBuyResponse model module.
 * @module model/ForceBuyResponse
 * @version 2021.12-dev21
 */
class ForceBuyResponse {
    /**
     * Constructs a new <code>ForceBuyResponse</code>.
     * @alias module:model/ForceBuyResponse
     * @implements module:model/TradeSchema
     * @implements module:model/StatusMsg
     * @param tradeId {Number} 
     * @param pair {String} 
     * @param isOpen {Boolean} 
     * @param exchange {String} 
     * @param amount {Number} 
     * @param amountRequested {Number} 
     * @param stakeAmount {Number} 
     * @param strategy {String} 
     * @param timeframe {Number} 
     * @param openDate {String} 
     * @param openTimestamp {Number} 
     * @param openRate {Number} 
     * @param openTradeValue {Number} 
     * @param status {String} 
     */
    constructor(tradeId, pair, isOpen, exchange, amount, amountRequested, stakeAmount, strategy, timeframe, openDate, openTimestamp, openRate, openTradeValue, status) { 
        TradeSchema.initialize(this, tradeId, pair, isOpen, exchange, amount, amountRequested, stakeAmount, strategy, timeframe, openDate, openTimestamp, openRate, openTradeValue);StatusMsg.initialize(this, status);
        ForceBuyResponse.initialize(this, tradeId, pair, isOpen, exchange, amount, amountRequested, stakeAmount, strategy, timeframe, openDate, openTimestamp, openRate, openTradeValue, status);
    }

    /**
     * Initializes the fields of this object.
     * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
     * Only for internal use.
     */
    static initialize(obj, tradeId, pair, isOpen, exchange, amount, amountRequested, stakeAmount, strategy, timeframe, openDate, openTimestamp, openRate, openTradeValue, status) { 
        obj['trade_id'] = tradeId;
        obj['pair'] = pair;
        obj['is_open'] = isOpen;
        obj['exchange'] = exchange;
        obj['amount'] = amount;
        obj['amount_requested'] = amountRequested;
        obj['stake_amount'] = stakeAmount;
        obj['strategy'] = strategy;
        obj['timeframe'] = timeframe;
        obj['open_date'] = openDate;
        obj['open_timestamp'] = openTimestamp;
        obj['open_rate'] = openRate;
        obj['open_trade_value'] = openTradeValue;
        obj['status'] = status;
    }

    /**
     * Constructs a <code>ForceBuyResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ForceBuyResponse} obj Optional instance to populate.
     * @return {module:model/ForceBuyResponse} The populated <code>ForceBuyResponse</code> instance.
     */
    static constructFromObject(data, obj) {
        if (data) {
            obj = obj || new ForceBuyResponse();
            TradeSchema.constructFromObject(data, obj);
            StatusMsg.constructFromObject(data, obj);

            if (data.hasOwnProperty('trade_id')) {
                obj['trade_id'] = ApiClient.convertToType(data['trade_id'], 'Number');
            }
            if (data.hasOwnProperty('pair')) {
                obj['pair'] = ApiClient.convertToType(data['pair'], 'String');
            }
            if (data.hasOwnProperty('is_open')) {
                obj['is_open'] = ApiClient.convertToType(data['is_open'], 'Boolean');
            }
            if (data.hasOwnProperty('exchange')) {
                obj['exchange'] = ApiClient.convertToType(data['exchange'], 'String');
            }
            if (data.hasOwnProperty('amount')) {
                obj['amount'] = ApiClient.convertToType(data['amount'], 'Number');
            }
            if (data.hasOwnProperty('amount_requested')) {
                obj['amount_requested'] = ApiClient.convertToType(data['amount_requested'], 'Number');
            }
            if (data.hasOwnProperty('stake_amount')) {
                obj['stake_amount'] = ApiClient.convertToType(data['stake_amount'], 'Number');
            }
            if (data.hasOwnProperty('strategy')) {
                obj['strategy'] = ApiClient.convertToType(data['strategy'], 'String');
            }
            if (data.hasOwnProperty('buy_tag')) {
                obj['buy_tag'] = ApiClient.convertToType(data['buy_tag'], 'String');
            }
            if (data.hasOwnProperty('timeframe')) {
                obj['timeframe'] = ApiClient.convertToType(data['timeframe'], 'Number');
            }
            if (data.hasOwnProperty('fee_open')) {
                obj['fee_open'] = ApiClient.convertToType(data['fee_open'], 'Number');
            }
            if (data.hasOwnProperty('fee_open_cost')) {
                obj['fee_open_cost'] = ApiClient.convertToType(data['fee_open_cost'], 'Number');
            }
            if (data.hasOwnProperty('fee_open_currency')) {
                obj['fee_open_currency'] = ApiClient.convertToType(data['fee_open_currency'], 'String');
            }
            if (data.hasOwnProperty('fee_close')) {
                obj['fee_close'] = ApiClient.convertToType(data['fee_close'], 'Number');
            }
            if (data.hasOwnProperty('fee_close_cost')) {
                obj['fee_close_cost'] = ApiClient.convertToType(data['fee_close_cost'], 'Number');
            }
            if (data.hasOwnProperty('fee_close_currency')) {
                obj['fee_close_currency'] = ApiClient.convertToType(data['fee_close_currency'], 'String');
            }
            if (data.hasOwnProperty('open_date')) {
                obj['open_date'] = ApiClient.convertToType(data['open_date'], 'String');
            }
            if (data.hasOwnProperty('open_timestamp')) {
                obj['open_timestamp'] = ApiClient.convertToType(data['open_timestamp'], 'Number');
            }
            if (data.hasOwnProperty('open_rate')) {
                obj['open_rate'] = ApiClient.convertToType(data['open_rate'], 'Number');
            }
            if (data.hasOwnProperty('open_rate_requested')) {
                obj['open_rate_requested'] = ApiClient.convertToType(data['open_rate_requested'], 'Number');
            }
            if (data.hasOwnProperty('open_trade_value')) {
                obj['open_trade_value'] = ApiClient.convertToType(data['open_trade_value'], 'Number');
            }
            if (data.hasOwnProperty('close_date')) {
                obj['close_date'] = ApiClient.convertToType(data['close_date'], 'String');
            }
            if (data.hasOwnProperty('close_timestamp')) {
                obj['close_timestamp'] = ApiClient.convertToType(data['close_timestamp'], 'Number');
            }
            if (data.hasOwnProperty('close_rate')) {
                obj['close_rate'] = ApiClient.convertToType(data['close_rate'], 'Number');
            }
            if (data.hasOwnProperty('close_rate_requested')) {
                obj['close_rate_requested'] = ApiClient.convertToType(data['close_rate_requested'], 'Number');
            }
            if (data.hasOwnProperty('close_profit')) {
                obj['close_profit'] = ApiClient.convertToType(data['close_profit'], 'Number');
            }
            if (data.hasOwnProperty('close_profit_pct')) {
                obj['close_profit_pct'] = ApiClient.convertToType(data['close_profit_pct'], 'Number');
            }
            if (data.hasOwnProperty('close_profit_abs')) {
                obj['close_profit_abs'] = ApiClient.convertToType(data['close_profit_abs'], 'Number');
            }
            if (data.hasOwnProperty('profit_ratio')) {
                obj['profit_ratio'] = ApiClient.convertToType(data['profit_ratio'], 'Number');
            }
            if (data.hasOwnProperty('profit_pct')) {
                obj['profit_pct'] = ApiClient.convertToType(data['profit_pct'], 'Number');
            }
            if (data.hasOwnProperty('profit_abs')) {
                obj['profit_abs'] = ApiClient.convertToType(data['profit_abs'], 'Number');
            }
            if (data.hasOwnProperty('profit_fiat')) {
                obj['profit_fiat'] = ApiClient.convertToType(data['profit_fiat'], 'Number');
            }
            if (data.hasOwnProperty('sell_reason')) {
                obj['sell_reason'] = ApiClient.convertToType(data['sell_reason'], 'String');
            }
            if (data.hasOwnProperty('sell_order_status')) {
                obj['sell_order_status'] = ApiClient.convertToType(data['sell_order_status'], 'String');
            }
            if (data.hasOwnProperty('stop_loss_abs')) {
                obj['stop_loss_abs'] = ApiClient.convertToType(data['stop_loss_abs'], 'Number');
            }
            if (data.hasOwnProperty('stop_loss_ratio')) {
                obj['stop_loss_ratio'] = ApiClient.convertToType(data['stop_loss_ratio'], 'Number');
            }
            if (data.hasOwnProperty('stop_loss_pct')) {
                obj['stop_loss_pct'] = ApiClient.convertToType(data['stop_loss_pct'], 'Number');
            }
            if (data.hasOwnProperty('stoploss_order_id')) {
                obj['stoploss_order_id'] = ApiClient.convertToType(data['stoploss_order_id'], 'String');
            }
            if (data.hasOwnProperty('stoploss_last_update')) {
                obj['stoploss_last_update'] = ApiClient.convertToType(data['stoploss_last_update'], 'String');
            }
            if (data.hasOwnProperty('stoploss_last_update_timestamp')) {
                obj['stoploss_last_update_timestamp'] = ApiClient.convertToType(data['stoploss_last_update_timestamp'], 'Number');
            }
            if (data.hasOwnProperty('initial_stop_loss_abs')) {
                obj['initial_stop_loss_abs'] = ApiClient.convertToType(data['initial_stop_loss_abs'], 'Number');
            }
            if (data.hasOwnProperty('initial_stop_loss_ratio')) {
                obj['initial_stop_loss_ratio'] = ApiClient.convertToType(data['initial_stop_loss_ratio'], 'Number');
            }
            if (data.hasOwnProperty('initial_stop_loss_pct')) {
                obj['initial_stop_loss_pct'] = ApiClient.convertToType(data['initial_stop_loss_pct'], 'Number');
            }
            if (data.hasOwnProperty('min_rate')) {
                obj['min_rate'] = ApiClient.convertToType(data['min_rate'], 'Number');
            }
            if (data.hasOwnProperty('max_rate')) {
                obj['max_rate'] = ApiClient.convertToType(data['max_rate'], 'Number');
            }
            if (data.hasOwnProperty('open_order_id')) {
                obj['open_order_id'] = ApiClient.convertToType(data['open_order_id'], 'String');
            }
            if (data.hasOwnProperty('status')) {
                obj['status'] = ApiClient.convertToType(data['status'], 'String');
            }
        }
        return obj;
    }


}

/**
 * @member {Number} trade_id
 */
ForceBuyResponse.prototype['trade_id'] = undefined;

/**
 * @member {String} pair
 */
ForceBuyResponse.prototype['pair'] = undefined;

/**
 * @member {Boolean} is_open
 */
ForceBuyResponse.prototype['is_open'] = undefined;

/**
 * @member {String} exchange
 */
ForceBuyResponse.prototype['exchange'] = undefined;

/**
 * @member {Number} amount
 */
ForceBuyResponse.prototype['amount'] = undefined;

/**
 * @member {Number} amount_requested
 */
ForceBuyResponse.prototype['amount_requested'] = undefined;

/**
 * @member {Number} stake_amount
 */
ForceBuyResponse.prototype['stake_amount'] = undefined;

/**
 * @member {String} strategy
 */
ForceBuyResponse.prototype['strategy'] = undefined;

/**
 * @member {String} buy_tag
 */
ForceBuyResponse.prototype['buy_tag'] = undefined;

/**
 * @member {Number} timeframe
 */
ForceBuyResponse.prototype['timeframe'] = undefined;

/**
 * @member {Number} fee_open
 */
ForceBuyResponse.prototype['fee_open'] = undefined;

/**
 * @member {Number} fee_open_cost
 */
ForceBuyResponse.prototype['fee_open_cost'] = undefined;

/**
 * @member {String} fee_open_currency
 */
ForceBuyResponse.prototype['fee_open_currency'] = undefined;

/**
 * @member {Number} fee_close
 */
ForceBuyResponse.prototype['fee_close'] = undefined;

/**
 * @member {Number} fee_close_cost
 */
ForceBuyResponse.prototype['fee_close_cost'] = undefined;

/**
 * @member {String} fee_close_currency
 */
ForceBuyResponse.prototype['fee_close_currency'] = undefined;

/**
 * @member {String} open_date
 */
ForceBuyResponse.prototype['open_date'] = undefined;

/**
 * @member {Number} open_timestamp
 */
ForceBuyResponse.prototype['open_timestamp'] = undefined;

/**
 * @member {Number} open_rate
 */
ForceBuyResponse.prototype['open_rate'] = undefined;

/**
 * @member {Number} open_rate_requested
 */
ForceBuyResponse.prototype['open_rate_requested'] = undefined;

/**
 * @member {Number} open_trade_value
 */
ForceBuyResponse.prototype['open_trade_value'] = undefined;

/**
 * @member {String} close_date
 */
ForceBuyResponse.prototype['close_date'] = undefined;

/**
 * @member {Number} close_timestamp
 */
ForceBuyResponse.prototype['close_timestamp'] = undefined;

/**
 * @member {Number} close_rate
 */
ForceBuyResponse.prototype['close_rate'] = undefined;

/**
 * @member {Number} close_rate_requested
 */
ForceBuyResponse.prototype['close_rate_requested'] = undefined;

/**
 * @member {Number} close_profit
 */
ForceBuyResponse.prototype['close_profit'] = undefined;

/**
 * @member {Number} close_profit_pct
 */
ForceBuyResponse.prototype['close_profit_pct'] = undefined;

/**
 * @member {Number} close_profit_abs
 */
ForceBuyResponse.prototype['close_profit_abs'] = undefined;

/**
 * @member {Number} profit_ratio
 */
ForceBuyResponse.prototype['profit_ratio'] = undefined;

/**
 * @member {Number} profit_pct
 */
ForceBuyResponse.prototype['profit_pct'] = undefined;

/**
 * @member {Number} profit_abs
 */
ForceBuyResponse.prototype['profit_abs'] = undefined;

/**
 * @member {Number} profit_fiat
 */
ForceBuyResponse.prototype['profit_fiat'] = undefined;

/**
 * @member {String} sell_reason
 */
ForceBuyResponse.prototype['sell_reason'] = undefined;

/**
 * @member {String} sell_order_status
 */
ForceBuyResponse.prototype['sell_order_status'] = undefined;

/**
 * @member {Number} stop_loss_abs
 */
ForceBuyResponse.prototype['stop_loss_abs'] = undefined;

/**
 * @member {Number} stop_loss_ratio
 */
ForceBuyResponse.prototype['stop_loss_ratio'] = undefined;

/**
 * @member {Number} stop_loss_pct
 */
ForceBuyResponse.prototype['stop_loss_pct'] = undefined;

/**
 * @member {String} stoploss_order_id
 */
ForceBuyResponse.prototype['stoploss_order_id'] = undefined;

/**
 * @member {String} stoploss_last_update
 */
ForceBuyResponse.prototype['stoploss_last_update'] = undefined;

/**
 * @member {Number} stoploss_last_update_timestamp
 */
ForceBuyResponse.prototype['stoploss_last_update_timestamp'] = undefined;

/**
 * @member {Number} initial_stop_loss_abs
 */
ForceBuyResponse.prototype['initial_stop_loss_abs'] = undefined;

/**
 * @member {Number} initial_stop_loss_ratio
 */
ForceBuyResponse.prototype['initial_stop_loss_ratio'] = undefined;

/**
 * @member {Number} initial_stop_loss_pct
 */
ForceBuyResponse.prototype['initial_stop_loss_pct'] = undefined;

/**
 * @member {Number} min_rate
 */
ForceBuyResponse.prototype['min_rate'] = undefined;

/**
 * @member {Number} max_rate
 */
ForceBuyResponse.prototype['max_rate'] = undefined;

/**
 * @member {String} open_order_id
 */
ForceBuyResponse.prototype['open_order_id'] = undefined;

/**
 * @member {String} status
 */
ForceBuyResponse.prototype['status'] = undefined;


// Implement TradeSchema interface:
/**
 * @member {Number} trade_id
 */
TradeSchema.prototype['trade_id'] = undefined;
/**
 * @member {String} pair
 */
TradeSchema.prototype['pair'] = undefined;
/**
 * @member {Boolean} is_open
 */
TradeSchema.prototype['is_open'] = undefined;
/**
 * @member {String} exchange
 */
TradeSchema.prototype['exchange'] = undefined;
/**
 * @member {Number} amount
 */
TradeSchema.prototype['amount'] = undefined;
/**
 * @member {Number} amount_requested
 */
TradeSchema.prototype['amount_requested'] = undefined;
/**
 * @member {Number} stake_amount
 */
TradeSchema.prototype['stake_amount'] = undefined;
/**
 * @member {String} strategy
 */
TradeSchema.prototype['strategy'] = undefined;
/**
 * @member {String} buy_tag
 */
TradeSchema.prototype['buy_tag'] = undefined;
/**
 * @member {Number} timeframe
 */
TradeSchema.prototype['timeframe'] = undefined;
/**
 * @member {Number} fee_open
 */
TradeSchema.prototype['fee_open'] = undefined;
/**
 * @member {Number} fee_open_cost
 */
TradeSchema.prototype['fee_open_cost'] = undefined;
/**
 * @member {String} fee_open_currency
 */
TradeSchema.prototype['fee_open_currency'] = undefined;
/**
 * @member {Number} fee_close
 */
TradeSchema.prototype['fee_close'] = undefined;
/**
 * @member {Number} fee_close_cost
 */
TradeSchema.prototype['fee_close_cost'] = undefined;
/**
 * @member {String} fee_close_currency
 */
TradeSchema.prototype['fee_close_currency'] = undefined;
/**
 * @member {String} open_date
 */
TradeSchema.prototype['open_date'] = undefined;
/**
 * @member {Number} open_timestamp
 */
TradeSchema.prototype['open_timestamp'] = undefined;
/**
 * @member {Number} open_rate
 */
TradeSchema.prototype['open_rate'] = undefined;
/**
 * @member {Number} open_rate_requested
 */
TradeSchema.prototype['open_rate_requested'] = undefined;
/**
 * @member {Number} open_trade_value
 */
TradeSchema.prototype['open_trade_value'] = undefined;
/**
 * @member {String} close_date
 */
TradeSchema.prototype['close_date'] = undefined;
/**
 * @member {Number} close_timestamp
 */
TradeSchema.prototype['close_timestamp'] = undefined;
/**
 * @member {Number} close_rate
 */
TradeSchema.prototype['close_rate'] = undefined;
/**
 * @member {Number} close_rate_requested
 */
TradeSchema.prototype['close_rate_requested'] = undefined;
/**
 * @member {Number} close_profit
 */
TradeSchema.prototype['close_profit'] = undefined;
/**
 * @member {Number} close_profit_pct
 */
TradeSchema.prototype['close_profit_pct'] = undefined;
/**
 * @member {Number} close_profit_abs
 */
TradeSchema.prototype['close_profit_abs'] = undefined;
/**
 * @member {Number} profit_ratio
 */
TradeSchema.prototype['profit_ratio'] = undefined;
/**
 * @member {Number} profit_pct
 */
TradeSchema.prototype['profit_pct'] = undefined;
/**
 * @member {Number} profit_abs
 */
TradeSchema.prototype['profit_abs'] = undefined;
/**
 * @member {Number} profit_fiat
 */
TradeSchema.prototype['profit_fiat'] = undefined;
/**
 * @member {String} sell_reason
 */
TradeSchema.prototype['sell_reason'] = undefined;
/**
 * @member {String} sell_order_status
 */
TradeSchema.prototype['sell_order_status'] = undefined;
/**
 * @member {Number} stop_loss_abs
 */
TradeSchema.prototype['stop_loss_abs'] = undefined;
/**
 * @member {Number} stop_loss_ratio
 */
TradeSchema.prototype['stop_loss_ratio'] = undefined;
/**
 * @member {Number} stop_loss_pct
 */
TradeSchema.prototype['stop_loss_pct'] = undefined;
/**
 * @member {String} stoploss_order_id
 */
TradeSchema.prototype['stoploss_order_id'] = undefined;
/**
 * @member {String} stoploss_last_update
 */
TradeSchema.prototype['stoploss_last_update'] = undefined;
/**
 * @member {Number} stoploss_last_update_timestamp
 */
TradeSchema.prototype['stoploss_last_update_timestamp'] = undefined;
/**
 * @member {Number} initial_stop_loss_abs
 */
TradeSchema.prototype['initial_stop_loss_abs'] = undefined;
/**
 * @member {Number} initial_stop_loss_ratio
 */
TradeSchema.prototype['initial_stop_loss_ratio'] = undefined;
/**
 * @member {Number} initial_stop_loss_pct
 */
TradeSchema.prototype['initial_stop_loss_pct'] = undefined;
/**
 * @member {Number} min_rate
 */
TradeSchema.prototype['min_rate'] = undefined;
/**
 * @member {Number} max_rate
 */
TradeSchema.prototype['max_rate'] = undefined;
/**
 * @member {String} open_order_id
 */
TradeSchema.prototype['open_order_id'] = undefined;
// Implement StatusMsg interface:
/**
 * @member {String} status
 */
StatusMsg.prototype['status'] = undefined;




export default ForceBuyResponse;

